
/**
 * \mainpage BIU - Bioinformatic Utilities
 *
 * This document provides reference information about the
 * <A HREF="http://www.bioinf.uni-freiburg.de/SW/BIU/">Bioinformatic Utility Library</A>.
 *
 * \section SecGoals The goal
 *
 * This C++ programming library provides a collection of reusable code fragments
 * and classes for different purposes.
 *
 * \section SecFeatures Features e.g.
 *
 * - some conversion functions concerning std::string
 * - Timer class for velocimetries
 * - OptionParser for type assured program parameter parsing and help output
 *   generation
 * - a template Matrix class including matrix operations
 * - a Virtual list as an abstract list that generates its content
 *
 * Additionally, the documentation also features the following parts:
 *  - \ref PageInstallation
 *  - \ref PageTests
 *
 * The following lists and indices are available
 *  - <a class="el" href="annotated.html">List of all classes including brief documentation</a>
 *  - <a class="el" href="namespaces.html">List of all namespaces including brief documentation</a>
 *  - <a class="el" href="files.html">List of all files</a>
 *  - <a class="el" href="hierarchy.html">Class hierarchy</a>
 *  - <a class="el" href="classes.html">Alphabetical class index</a>
 *  - <a class="el" href="namespacemembers.html">Namespace members</a>
 *  - <a class="el" href="functions.html">Class members</a>
 *  - <a class="el" href="globals.html">File members</a>
 */



/**
 * \page PageInstallation Installation
 *
 * Follow this steps to create a local version of the ELL:
 *
 * - download and unzip the BIU source package distribution (TODO: INSERT LINK)
 * - run "autoconf" to generate the configure script
 * - run "automake"
 * - run "./configure --help" to get an overview of further possible parameters
 * - run "./configure" with your desired parameters to generate the Makefiles
 * - "make" to generate the library
 *
 * - "make test" to test if everything works fine
 *
 * - "make doc" to generate the html documentation (if selected during the
 *   configure call)
 * - "make doxygen-doc" to generate the whole documentation
 *
 *
 */

/**
 * \page PageTests Test cases and usage examples
 *
 * To check if the BIU does function as expected a test case was implemented
 * for each non-abstracted class.
 *
 * The source code can be used as an example for the usage of the BIU-classes.
 *
 * All files can be found in a subfolder named "tests" in the BIU root
 * directory. They are named in the format "testCLASSNAME.cc".
 *
 */